EclipseEngine
Date: 2022-09-03

com.parctechnologies.eclipse

## Interface EclipseEngine

- All Superinterfaces:
    EclipseConnection
  All Known Implementing Classes:
    EmbeddedEclipse, OutOfProcessEclipse

      public interface EclipseEngine
      extends EclipseConnection

  Interface of objects providing "ownership" of an ECLiPSe engine. As well as the functionality provided by the `EclipseConnection` interface, classes which implement EclipseEngine also allow access to the ECLiPSe engine's standard streams: `stdin`, `stdout` and `sterr`.
  See Also:
    `EclipseConnection`, `EmbeddedEclipse`, `OutOfProcessEclipse`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `FromEclipseQueue` | `getEclipseStderr()` Return a FromEclipseQueue which allows access to the ECLiPSe engine's `stderr` stream.
    `ToEclipseQueue` | `getEclipseStdin()` Return a ToEclipseQueue which allows access to the ECLiPSe engine's `stdin` stream.
    `FromEclipseQueue` | `getEclipseStdout()` Return a FromEclipseQueue which allows access to the ECLiPSe engine's `stdout` stream.
    `boolean` | `isUsingQueues()` Query the ECLiPSe engine's "use queues" flag.

    - ### Methods inherited from interface com.parctechnologies.eclipse.EclipseConnection

      `compile, getAsyncEclipseQueue, getFromEclipseQueue, getPath, getPeerName, getToEclipseQueue, registerMultitask, rpc, rpc, rpc, rpc, rpc, rpc, rpc, rpc, rpc`

- - ### Method Detail

    - #### getEclipseStdin

          ToEclipseQueue getEclipseStdin()
                                  throws EclipseTerminatedException

      Return a ToEclipseQueue which allows access to the ECLiPSe engine's `stdin` stream. Returns null if the ECLiPSe was not set up to use queue objects for its standard streams (see `EclipseEngineOptions`).
      Throws:
        `EclipseTerminatedException` - if the ECLiPSe engine has been destroyed or disconnected.

    - #### getEclipseStdout

          FromEclipseQueue getEclipseStdout()
                                     throws EclipseTerminatedException

      Return a FromEclipseQueue which allows access to the ECLiPSe engine's `stdout` stream. Returns null if the ECLiPSe was not set up to use queue objects for its standard streams (see `EclipseEngineOptions`).
      Throws:
        `EclipseTerminatedException` - if the ECLiPSe engine has been destroyed.

    - #### getEclipseStderr

          FromEclipseQueue getEclipseStderr()
                                     throws EclipseTerminatedException

      Return a FromEclipseQueue which allows access to the ECLiPSe engine's `stderr` stream. Returns null if the ECLiPSe was not set up to use queue objects for its standard streams (see `EclipseEngineOptions`).
      Throws:
        `EclipseTerminatedException` - if the ECLiPSe engine has been destroyed.

    - #### isUsingQueues

          boolean isUsingQueues()

      Query the ECLiPSe engine's "use queues" flag. If true, ECLiPSe's standard streams (stdin, stdout and stderr) have been linked to FromEclipseQueue/ToEclipseQueue objects: if false, they have been linked to the operating system standard streams.